<template>
  <v-app>
    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color:white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- table summary -->
    <v-row>
      <v-col cols="12" lg="12" md="12" sm="12">
        <v-card elevation="0">
          <v-container grid-list-xs>
            <v-row>
              <v-col cols="12" lg="12" md="12" sm="12">
                <v-card-title><h1>Summary</h1></v-card-title>
                <!-- ภาพรวมรายปี -->
                <div>
                  <v-card-title>
                    <v-row>
                      <v-col cols="12" sm="12" md="5" lg="5">
                        <v-container class="py-2">
                          <span style="font-size: 27px">
                            <v-icon>mdi-calendar-clock</v-icon> ภาพรวมรายปี
                            <v-icon>mdi-chevron-right</v-icon>
                            {{ select_year }}
                          </span>
                          <v-divider style="width: 100%"></v-divider>
                        </v-container>
                      </v-col>
                      <v-col cols="12" sm="12" md="3" lg="3"> </v-col>
                      <v-col cols="12" sm="12" md="4" lg="4">
                        <v-container class="py-0">
                          <v-select
                            type="year"
                            class="pa-0"
                            :items="items"
                            v-model="select_year"
                            label="select year for filter"
                            dense
                            outlined
                          ></v-select>
                        </v-container>
                      </v-col>
                    </v-row>
                  </v-card-title>
                  <v-card>
                    <v-card-title>
                      <v-spacer></v-spacer>
                      <v-text-field
                        v-model="search_year"
                        placeholder="Search Year"
                        append-icon="mdi-magnify"
                        single-line
                        hide-details
                      ></v-text-field>
                    </v-card-title>
                    <v-data-table
                      :headers="headers_year"
                      :search="search_year"
                      :items="desserts_year"
                      :items-per-page="5"
                      class="elevation-0"
                    >
                      <template v-slot:item.over_film="{ item }">
                        <span v-if="item.over_film < 0" style="color:red">
                          {{ Math.abs(item.over_film) }}
                        </span>
                        <span v-else>
                          {{ item.over_film }}
                        </span>
                      </template>
                      <template v-slot:item.actions="{ item }">
                        <v-tooltip top>
                          <template v-slot:activator="{ on, attrs }">
                            <v-icon
                              v-bind="attrs"
                              v-on="on"
                              class="mx-0"
                              small
                              color="primary"
                              @click="openDialog_year(item)"
                              >mdi-eye</v-icon
                            >
                          </template>
                          <span>Detail</span>
                        </v-tooltip>
                      </template>
                    </v-data-table>
                  </v-card>
                  <v-dialog v-model="dialog_year" persistent max-width="500">
                    <v-card>
                      <v-card-title class="headline" style="color: white; background: #428bca">{{ data_year.hospital_name_th }}</v-card-title>
                      <v-card-text>
                        <v-simple-table>
                          <template v-slot:default>
                            <thead>
                              <tr>
                                <th class="text-left">
                                  Disease
                                </th>
                                <th class="text-left">
                                  Film
                                </th>
                              </tr>
                            </thead>
                            <tbody>
                              <tr
                                v-for="item in data_dialog_year"
                                :key="item.name"
                              >
                                <td>{{ item.name }}</td>
                                <td>{{ item.value }}</td>
                              </tr>
                            </tbody>
                          </template>
                        </v-simple-table>
                      </v-card-text>
                      <v-divider></v-divider>
                      <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn
                          color="blue"
                          @click="dialog_year = false"
                          style="color: white"
                          >Submit</v-btn
                        >
                      </v-card-actions>
                    </v-card>
                  </v-dialog>
                </div>
                <!-- ภาพรวมรายเดือน -->
                <div class="mt-9">
                  <v-card-title>
                    <v-row>
                      <v-col cols="12" sm="12" md="5" lg="5">
                        <v-container class="py-2">
                          <span style="font-size: 27px">
                            <v-icon>mdi-calendar-month</v-icon> ภาพรวมรายเดือน
                            <v-icon>mdi-chevron-right</v-icon>
                            {{ select_date }}
                          </span>
                          <v-divider style="width: 100%"></v-divider>
                        </v-container>
                      </v-col>
                      <v-col cols="12" sm="12" md="3" lg="3"> </v-col>
                      <v-col cols="12" sm="12" md="4" lg="4">
                        <v-container class="py-0">
                          <v-dialog
                            ref="dialog"
                            v-model="modal"
                            :return-value.sync="date"
                            persistent
                            width="290px"
                          >
                            <template v-slot:activator="{ on, attrs }">
                              <v-text-field
                                v-model="select_date"
                                label="Select year Select month"
                                append-icon="mdi-calendar"
                                @click:append="modal = true"
                                readonly
                                v-bind="attrs"
                                v-on="on"
                                outlined
                                dense
                              ></v-text-field>
                            </template>
                            <v-date-picker
                              v-model="select_date"
                              scrollable
                              type="month"
                            >
                              <v-spacer></v-spacer>
                              <v-btn
                                text
                                color="primary"
                                @click="modal = false"
                              >
                                Cancel
                              </v-btn>
                              <v-btn
                                text
                                color="primary"
                                @click="filter_month()"
                              >
                                OK
                              </v-btn>
                            </v-date-picker>
                          </v-dialog>
                        </v-container>
                      </v-col>
                    </v-row>
                  </v-card-title>
                  <!-- รายเดือน -->
                  <v-card>
                    <v-card-title>
                      <v-spacer></v-spacer>
                      <v-text-field
                        v-model="search_month"
                        append-icon="mdi-magnify"
                        placeholder="Search Month"
                        single-line
                        hide-details
                      ></v-text-field>
                    </v-card-title>
                    <v-data-table
                      :headers="headers_month"
                      :search="search_month"
                      :items="desserts_month"
                      :items-per-page="5"
                      class="elevation-0"
                    >
                      <template v-slot:item.over_film="{ item }">
                        <span v-if="item.over_film < 0" style="color:red">
                          {{ Math.abs(item.over_film) }}
                        </span>
                        <span v-else> {{ item.over_film }}</span>
                      </template>

                      <template v-slot:item.actions="{ item }">
                        <v-tooltip top>
                          <template v-slot:activator="{ on, attrs }">
                            <v-icon
                              v-bind="attrs"
                              v-on="on"
                              class="mx-0"
                              small
                              color="primary"
                              @click="openDialog_month(item)"
                              >mdi-eye</v-icon
                            >
                          </template>
                          <span>Detail</span>
                        </v-tooltip>
                      </template>
                    </v-data-table>
                  </v-card>
                  <v-dialog v-model="dialog_month" persistent max-width="500">
                    <v-card>
                      <v-card-title class="headline" style="color: white; background: #428bca">
                        {{ data_month.hospital_name_th }}
                      </v-card-title>
                      <v-card-text>
                        <v-simple-table>
                          <template v-slot:default>
                            <thead>
                              <tr>
                                <th class="text-left">
                                  Disease
                                </th>
                                <th class="text-left">
                                  Film
                                </th>
                              </tr>
                            </thead>
                            <tbody>
                              <tr
                                v-for="item in data_dialog_month"
                                :key="item.name"
                              >
                                <td>{{ item.name }}</td>
                                <td>{{ item.value }}</td>
                              </tr>
                            </tbody>
                          </template>
                        </v-simple-table>
                      </v-card-text>
                      <v-divider></v-divider>
                      <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn
                          color="blue"
                          @click="dialog_month = false"
                          style="color: white"
                          >Submit</v-btn
                        >
                      </v-card-actions>
                    </v-card>
                  </v-dialog>
                </div>
              </v-col>
            </v-row>
          </v-container>
        </v-card>
      </v-col>
    </v-row>
    <!-- table summary -->
  </v-app>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      session_id: this.$cookies.get("info_login").session_id,
      search_year: "",
      search_month: "",
      dialog_loader: false,
      dialog_year: false,
      data_year: {},
      data_month: {},
      dialog_month: false,
      modal: false,
      items: [],
      month: "",
      year: "",
      select_date: new Date().toISOString().substr(0, 10),
      select_year: new Date().toISOString().substr(0, 10),
      data_dialog_year: [],
      data_dialog_month: [],
      headers_year: [
        {
          text: "Hospital Name",
          align: "start",
          value: "hospital_name_th",
          sortable: false,
        },
        {
          text: "Package name",
          align: "start",
          value: "package_name",
          sortable: false,
        },
        {
          text: "Total Film",
          align: "start",
          value: "flim_upload",
          sortable: false,
        },
        {
          text: "Film Upload",
          align: "start",
          value: "Total",
          sortable: false,
        },
        {
          text: "Over Film",
          align: "start",
          value: "over_film",
          sortable: false,
        },
        {
          text: "Start using",
          align: "start",
          value: "startdate",
          sortable: false,
        },
        {
          text: "Expire",
          align: "start",
          value: "enddate",
          sortable: false,
        },
        {
          text: "Actions",
          align: "start",
          value: "actions",
          sortable: false,
        },
      ],
      headers_month: [
        {
          text: "Hospital Name",
          align: "start",
          value: "hospital_name_th",
          sortable: false,
        },
        {
          text: "Package name",
          align: "start",
          value: "package_name",
          sortable: false,
        },
        {
          text: "Total Film",
          align: "start",
          value: "flim_upload",
          sortable: false,
        },
        {
          text: "Film Upload",
          align: "start",
          value: "Total",
          sortable: false,
        },
        {
          text: "Over Film",
          align: "start",
          value: "over_film",
          sortable: false,
        },
        {
          text: "Start using",
          align: "start",
          value: "startdate",
          sortable: false,
        },
        {
          text: "Expire",
          align: "start",
          value: "enddate",
          sortable: false,
        },
        {
          text: "Actions",
          align: "start",
          value: "actions",
          sortable: false,
        },
      ],
      desserts_year: [],
      desserts_month: [],
    };
  },
  watch: {
    select_year(val) {
      console.log("select_year", val);
      this.get_year();
    },
    select_date(val) {
      console.log("select_year", moment(val).format("YYYY"));
      this.year = moment(val).format("YYYY");
      console.log("select_month", moment(val).format("MM"));
      this.month = moment(val).format("MM");
    },
  },
  mounted() {
    this.select_date = moment(this.select_date).format("YYYY-MM");
    // year //
    this.count_number = 0;
    this.select_year = moment(this.select_year).format("YYYY");
    let array_year = [];
    for (let index = this.select_year - 3; index <= this.select_year; index++) {
      array_year.push(String(index));
    }
    array_year.sort();
    array_year.sort(function(a, b) {
      return b - a;
    });
    this.items = array_year;
    this.select_year = moment(this.select_year).format("YYYY");
    this.get_year();
    console.log("select_date", this.select_date);
    this.year = moment(this.select_date).format("YYYY");
    this.month = moment(this.select_date).format("MM");
    this.get_month();
  },
  methods: {
    get_year() {
      console.log("get_year:", this.select_year);
      this.dialog_loader = true;
      this.axios
        .get(
          //  "http://5e25-2001-44c8-4360-fbf-4035-8a99-19f3-7cdb.ngrok.io" +
          process.env.VUE_APP_API +
            "/api/v3/summary/allhospital?user_id=" +
            this.$cookies.get("info_login").user_id +
            "&year=" +
            this.select_year,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then((response) => {
          this.dialog_loader = false;
          console.log("response-year", response.data.data);
          for (let index = 0; index < response.data.data.length; index++) {
            response.data.data[index].startdate = moment(response.data.data[index].startdate).format("YYYY-MM-DD");
            response.data.data[index].enddate = moment(response.data.data[index].enddate).format("YYYY-MM-DD");
            // calculate overfilm
            if (response.data.data[index].flim_upload == "unlimited") {
              response.data.data[index].over_film = "unlimited";
            } else if (response.data.data[index].flim_upload < response.data.data[index].Total) {
              response.data.data[index].over_film = response.data.data[index].flim_upload - response.data.data[index].Total;
            } else {
              response.data.data[index].over_film = 0;
            }
          }
          // console.log("response-year-final", response.data.data);
          this.desserts_year = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = true;
          console.log("error", error);
        });
    },
    get_month() {
      this.dialog_loader = true;
      console.log("get_month:", this.year + "-" + this.month);
      this.axios
        .get(
          // "http://5e25-2001-44c8-4360-fbf-4035-8a99-19f3-7cdb.ngrok.io" +
          process.env.VUE_APP_API +
            "/api/v3/summary/allhospital?user_id=" +
            this.$cookies.get("info_login").user_id +
            "&year=" +
            this.year +
            "&month=" +
            this.month,
          {
            headers: {
              Authorization: this.session_id,
            },
          }
        )
        .then((response) => {
          this.dialog_loader = false;
          console.log("response-month", response.data.data);
          for (let index = 0; index < response.data.data.length; index++) {
            // console.log(index, response.data.data[index].startdate);
            response.data.data[index].startdate = moment(response.data.data[index].startdate).format("YYYY-MM-DD");
            response.data.data[index].enddate = moment(response.data.data[index].enddate).format("YYYY-MM-DD");
            // total film
            if (response.data.data[index].flim_upload != "unlimited") {
              response.data.data[index].flim_upload =
                response.data.data[index].flim_upload / 12;
            }
            // overfilm
            // console.log("flim_upload", response.data.data[index].flim_upload);
            if (response.data.data[index].flim_upload == "unlimited") {
              response.data.data[index].over_film = "unlimited";
            } else if (response.data.data[index].flim_upload < response.data.data[index].Total) {
              response.data.data[index].over_film = response.data.data[index].flim_upload - response.data.data[index].Total;
            } else {
              response.data.data[index].over_film = 0;
            }
          }
          // console.log("response-month-final", response.data.data);
          this.desserts_month = response.data.data;
        })
        .catch((error) => {
          this.dialog_loader = true;
          console.log("error", error);
        });
    },

    openDialog_year(item) {
      this.data_dialog_year = [];
      console.log("dialog_year:", item);
      this.data_year = item;
      this.dialog_year = true;
      const selectedKeys = [
        "Abnormal",
        "Covid",
        "Emphysema",
        "Normal",
        "Pneumonia",
        "Pneumothorax",
        "Tuberculosis",
        "Total",
      ];

      const filteredKeys = Object.keys(item)
        .filter((key) => selectedKeys.includes(key))
        .reduce((obj, key) => {
          const objSelected = { name: key, value: item[key] };
          obj.push(objSelected);
          return obj;
        }, []);
      // สลับตำแหน่ง array
      [filteredKeys[6], filteredKeys[7]] = [filteredKeys[7], filteredKeys[6]];
      console.log("filteredKeys", filteredKeys);
      this.data_dialog_year = filteredKeys;
      console.log("data_dialog_year", this.data_dialog_year);
    },

    openDialog_month(item) {
      this.data_dialog_month = [];
      console.log("dialog_month:", item);
      this.data_month = item;
      this.dialog_month = true;
      const selectedKeys = [
        "Abnormal",
        "Covid",
        "Emphysema",
        "Normal",
        "Pneumonia",
        "Pneumothorax",
        "Tuberculosis",
        "Total",
      ];

      const filteredKeys = Object.keys(item)
        .filter((key) => selectedKeys.includes(key))
        .reduce((obj, key) => {
          const objSelected = { name: key, value: item[key] };
          obj.push(objSelected);
          return obj;
        }, []);
      // สลับตำแหน่ง array
      [filteredKeys[6], filteredKeys[7]] = [filteredKeys[7], filteredKeys[6]];
      console.log("filteredKeys", filteredKeys);
      this.data_dialog_month = filteredKeys;
    },

    filter_month() {
      this.modal = false;
      this.get_month();
    },
  },
};
</script>

<style></style>
